# Models

## The WebResult object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"WebResult":{"type":"object","description":"Standard response format for most Carte operations","properties":{"result":{"type":"string","enum":["OK","ERROR"],"description":"Result status of the operation"},"message":{"type":"string","description":"Human readable message describing the result"},"id":{"type":"string","description":"Unique identifier for the created/modified resource"}},"xml":{"name":"webresult"}}}}}
```

## The ErrorResponse object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"ErrorResponse":{"type":"object","description":"Error response format","properties":{"result":{"type":"string","enum":["ERROR"],"description":"Always ERROR for error responses"},"message":{"type":"string","description":"Error message describing what went wrong"},"exception":{"type":"string","description":"Exception details if available"}},"xml":{"name":"webresult"}}}}}
```

## The DatabaseConnection object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"DatabaseConnection":{"type":"object","description":"Database connection configuration","properties":{"id":{"type":"string","description":"Unique identifier for the database connection"},"name":{"type":"string","description":"Name of the database connection"},"hostname":{"type":"string","description":"Database server hostname"},"databaseName":{"type":"string","description":"Name of the database"},"databasePort":{"type":"string","description":"Database server port"},"username":{"type":"string","description":"Database username"},"password":{"type":"string","description":"Database password (may be encrypted or nullified for security)"},"accessType":{"type":"string","description":"Type of database access"},"accessTypeValue":{"type":"string","description":"Value for the access type"},"connectSql":{"type":"string","description":"SQL to execute on connection"},"usingConnectionPool":{"type":"boolean","description":"Whether to use connection pooling"},"initialPoolSize":{"type":"integer","description":"Initial connection pool size"},"maximumPoolSize":{"type":"integer","description":"Maximum connection pool size"},"partitioned":{"type":"boolean","description":"Whether the database is partitioned"},"changed":{"type":"boolean","description":"Whether the connection has been modified"},"quoteAllFields":{"type":"boolean","description":"Whether to quote all field names"},"streamingResults":{"type":"boolean","description":"Whether to use streaming results"},"forcingIdentifiersToLowerCase":{"type":"boolean","description":"Whether to force identifiers to lowercase"},"forcingIdentifiersToUpperCase":{"type":"boolean","description":"Whether to force identifiers to uppercase"},"usingDoubleDecimalAsSchemaTableSeparator":{"type":"boolean","description":"Whether to use double decimal as schema table separator"},"dataTablespace":{"type":"string","description":"Data tablespace name"},"indexTablespace":{"type":"string","description":"Index tablespace name"},"informixServername":{"type":"string","description":"Informix server name"},"SQLServerInstance":{"type":"string","nullable":true,"description":"SQL Server instance name"},"attributes":{"type":"object","description":"Additional connection attributes","additionalProperties":{"type":"string"}},"connectionPoolingProperties":{"type":"object","description":"Connection pooling properties","additionalProperties":{"type":"string"}},"extraOptions":{"type":"object","description":"Extra connection options","additionalProperties":{"type":"string"}},"databaseType":{"type":"object","description":"Database type information","properties":{"name":{"type":"string","description":"Database type name"},"shortName":{"type":"string","description":"Short name for the database type"},"defaultDatabasePort":{"type":"integer","description":"Default port for this database type"},"extraOptionsHelpUrl":{"type":"string","description":"URL for extra options help"},"supportedAccessTypes":{"type":"array","description":"Supported access types for this database","items":{"type":"string"}}}}}}}}}
```

## The RepositoryFileDto object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"RepositoryFileDto":{"type":"object","description":"Repository file data transfer object","properties":{"id":{"type":"string","description":"Unique identifier for the file"},"name":{"type":"string","description":"Name of the file"},"path":{"type":"string","description":"Full path to the file"},"folder":{"type":"boolean","description":"Whether this is a folder"},"hidden":{"type":"boolean","description":"Whether this file is hidden"},"versioned":{"type":"boolean","description":"Whether this file is versioned"},"locked":{"type":"boolean","description":"Whether this file is locked"},"fileSize":{"type":"integer","format":"int64","description":"Size of the file in bytes"},"createdDate":{"type":"string","format":"date-time","description":"When the file was created"},"lastModifiedDate":{"type":"string","format":"date-time","description":"When the file was last modified"},"ownerType":{"type":"integer","description":"Type of owner (USER, ROLE)"},"title":{"type":"string","description":"Title of the file"},"description":{"type":"string","description":"Description of the file"},"deletedDate":{"type":"string","format":"date-time","description":"When the file was deleted (if applicable)"},"locale":{"type":"string","description":"Locale of the file"},"originalParentFolderPath":{"type":"string","description":"Original parent folder path before deletion"},"versionId":{"type":"string","description":"Version identifier of the file"},"localePropertiesMapEntries":{"type":"array","description":"Locale-specific properties","items":{"type":"object","properties":{"locale":{"type":"string","description":"Locale identifier"},"properties":{"type":"array","description":"Key-value properties for this locale","items":{"type":"object","properties":{"key":{"type":"string","description":"Property key"},"value":{"type":"string","description":"Property value"}}}}}}}}}}}}
```

## The RepositoryFileAclDto object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"RepositoryFileAclDto":{"type":"object","description":"Repository file access control list","properties":{"id":{"type":"string","description":"Unique identifier for the ACL"},"owner":{"type":"string","description":"Owner of the file"},"ownerType":{"type":"integer","description":"Type of owner (USER, ROLE)"},"inheriting":{"type":"boolean","description":"Whether ACL inherits from parent"},"entriesInheriting":{"type":"boolean","description":"Whether entries inherit"},"aces":{"type":"array","description":"Access control entries","items":{"type":"object","properties":{"recipient":{"type":"string","description":"Recipient of the access control entry"},"recipientType":{"type":"integer","description":"Type of recipient (USER, ROLE)"},"permissions":{"type":"array","description":"Permissions granted","items":{"type":"integer"}}}}}}}}}}
```

## The RepositoryFileTreeDto object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"RepositoryFileTreeDto":{"type":"object","description":"Repository file tree structure","properties":{"file":{"$ref":"#/components/schemas/RepositoryFileDto"},"children":{"type":"array","description":"Child files and directories","items":{"$ref":"#/components/schemas/RepositoryFileTreeDto"}}}},"RepositoryFileDto":{"type":"object","description":"Repository file data transfer object","properties":{"id":{"type":"string","description":"Unique identifier for the file"},"name":{"type":"string","description":"Name of the file"},"path":{"type":"string","description":"Full path to the file"},"folder":{"type":"boolean","description":"Whether this is a folder"},"hidden":{"type":"boolean","description":"Whether this file is hidden"},"versioned":{"type":"boolean","description":"Whether this file is versioned"},"locked":{"type":"boolean","description":"Whether this file is locked"},"fileSize":{"type":"integer","format":"int64","description":"Size of the file in bytes"},"createdDate":{"type":"string","format":"date-time","description":"When the file was created"},"lastModifiedDate":{"type":"string","format":"date-time","description":"When the file was last modified"},"ownerType":{"type":"integer","description":"Type of owner (USER, ROLE)"},"title":{"type":"string","description":"Title of the file"},"description":{"type":"string","description":"Description of the file"},"deletedDate":{"type":"string","format":"date-time","description":"When the file was deleted (if applicable)"},"locale":{"type":"string","description":"Locale of the file"},"originalParentFolderPath":{"type":"string","description":"Original parent folder path before deletion"},"versionId":{"type":"string","description":"Version identifier of the file"},"localePropertiesMapEntries":{"type":"array","description":"Locale-specific properties","items":{"type":"object","properties":{"locale":{"type":"string","description":"Locale identifier"},"properties":{"type":"array","description":"Key-value properties for this locale","items":{"type":"object","properties":{"key":{"type":"string","description":"Property key"},"value":{"type":"string","description":"Property value"}}}}}}}}}}}}
```

## The RepositoryFileDtoWrapper object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"RepositoryFileDtoWrapper":{"type":"object","description":"Wrapper for list of repository files","properties":{"children":{"type":"array","description":"List of repository files","items":{"$ref":"#/components/schemas/RepositoryFileDto"}}},"xml":{"name":"repositoryFileDtoes"}},"RepositoryFileDto":{"type":"object","description":"Repository file data transfer object","properties":{"id":{"type":"string","description":"Unique identifier for the file"},"name":{"type":"string","description":"Name of the file"},"path":{"type":"string","description":"Full path to the file"},"folder":{"type":"boolean","description":"Whether this is a folder"},"hidden":{"type":"boolean","description":"Whether this file is hidden"},"versioned":{"type":"boolean","description":"Whether this file is versioned"},"locked":{"type":"boolean","description":"Whether this file is locked"},"fileSize":{"type":"integer","format":"int64","description":"Size of the file in bytes"},"createdDate":{"type":"string","format":"date-time","description":"When the file was created"},"lastModifiedDate":{"type":"string","format":"date-time","description":"When the file was last modified"},"ownerType":{"type":"integer","description":"Type of owner (USER, ROLE)"},"title":{"type":"string","description":"Title of the file"},"description":{"type":"string","description":"Description of the file"},"deletedDate":{"type":"string","format":"date-time","description":"When the file was deleted (if applicable)"},"locale":{"type":"string","description":"Locale of the file"},"originalParentFolderPath":{"type":"string","description":"Original parent folder path before deletion"},"versionId":{"type":"string","description":"Version identifier of the file"},"localePropertiesMapEntries":{"type":"array","description":"Locale-specific properties","items":{"type":"object","properties":{"locale":{"type":"string","description":"Locale identifier"},"properties":{"type":"array","description":"Key-value properties for this locale","items":{"type":"object","properties":{"key":{"type":"string","description":"Property key"},"value":{"type":"string","description":"Property value"}}}}}}}}}}}}
```

## The StringListWrapper object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"StringListWrapper":{"type":"object","description":"Wrapper for list of strings","properties":{"stringList":{"type":"array","description":"List of strings","items":{"type":"string"}}}}}}}
```

## The JobScheduleRequest object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"JobScheduleRequest":{"type":"object","description":"Request object for scheduling jobs and blockouts","properties":{"jobName":{"type":"string","description":"Name of the job"},"jobId":{"type":"string","description":"ID of the job (for updates)"},"simpleJobTrigger":{"type":"object","description":"Simple job trigger configuration","properties":{"uiPassParam":{"type":"string","description":"UI parameter for trigger type"},"repeatInterval":{"type":"integer","description":"Repeat interval in seconds"},"repeatCount":{"type":"integer","description":"Number of times to repeat (-1 for infinite)"},"startTime":{"type":"string","description":"Start time in ISO format"},"endTime":{"type":"string","description":"End time in ISO format"}}},"complexJobTrigger":{"type":"object","description":"Complex job trigger configuration","properties":{"uiPassParam":{"type":"string","description":"UI parameter for trigger type"},"daysOfWeek":{"type":"array","description":"Days of week when job should run","items":{"type":"integer"}},"startTime":{"type":"string","description":"Start time in ISO format"},"endTime":{"type":"string","description":"End time in ISO format"}}},"inputFile":{"type":"string","description":"Input file path"},"outputFile":{"type":"string","description":"Output file path"},"duration":{"type":"integer","description":"Duration in milliseconds for blockouts"},"timeZone":{"type":"string","description":"Time zone for the schedule"},"jobParameters":{"type":"object","description":"Job parameters","properties":{"name":{"type":"string","description":"Parameter name"},"type":{"type":"string","description":"Parameter type"},"stringValue":{"type":"string","description":"Parameter value"}}}}}}}}
```

## The JobRequest object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"JobRequest":{"type":"object","description":"Request object for job operations","properties":{"jobId":{"type":"string","description":"ID of the job"}}}}}}
```

## The Job object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"Job":{"type":"object","description":"Job information","properties":{"groupName":{"type":"string","description":"Group name of the job"},"jobId":{"type":"string","description":"Unique identifier for the job"},"jobName":{"type":"string","description":"Name of the job"},"jobParams":{"type":"array","description":"Job parameters","items":{"type":"object","properties":{"name":{"type":"string","description":"Parameter name"},"value":{"type":"string","description":"Parameter value"}}}},"jobTrigger":{"type":"object","description":"Job trigger configuration","properties":{"duration":{"type":"integer","description":"Duration of the trigger"},"startTime":{"type":"string","description":"Start time in ISO format"},"uiPassParam":{"type":"string","description":"UI parameter for trigger type"},"repeatCount":{"type":"integer","description":"Number of times to repeat"},"repeatInterval":{"type":"integer","description":"Repeat interval in seconds"}}},"lastRun":{"type":"string","description":"Last run time in ISO format"},"nextRun":{"type":"string","description":"Next run time in ISO format"},"state":{"type":"string","description":"Current state of the job"},"userName":{"type":"string","description":"User who owns the job"}}}}}}
```

## The JobWrapper object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"JobWrapper":{"type":"object","description":"Wrapper for job collections","properties":{"job":{"type":"array","description":"Array of jobs","items":{"$ref":"#/components/schemas/Job"}}}},"Job":{"type":"object","description":"Job information","properties":{"groupName":{"type":"string","description":"Group name of the job"},"jobId":{"type":"string","description":"Unique identifier for the job"},"jobName":{"type":"string","description":"Name of the job"},"jobParams":{"type":"array","description":"Job parameters","items":{"type":"object","properties":{"name":{"type":"string","description":"Parameter name"},"value":{"type":"string","description":"Parameter value"}}}},"jobTrigger":{"type":"object","description":"Job trigger configuration","properties":{"duration":{"type":"integer","description":"Duration of the trigger"},"startTime":{"type":"string","description":"Start time in ISO format"},"uiPassParam":{"type":"string","description":"UI parameter for trigger type"},"repeatCount":{"type":"integer","description":"Number of times to repeat"},"repeatInterval":{"type":"integer","description":"Repeat interval in seconds"}}},"lastRun":{"type":"string","description":"Last run time in ISO format"},"nextRun":{"type":"string","description":"Next run time in ISO format"},"state":{"type":"string","description":"Current state of the job"},"userName":{"type":"string","description":"User who owns the job"}}}}}}
```

## The BlockStatusProxy object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"BlockStatusProxy":{"type":"object","description":"Blockout status information","properties":{"partiallyBlocked":{"type":"boolean","description":"Whether the schedule is partially blocked"},"totallyBlocked":{"type":"boolean","description":"Whether the schedule is totally blocked"}}}}}}
```

## The RoleList object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"RoleList":{"type":"object","description":"List of roles in the platform","properties":{"roles":{"type":"array","description":"Array of role names","items":{"type":"string"}}},"xml":{"name":"roleList"}}}}}
```

## The UserList object

```json
{"openapi":"3.0.3","info":{"title":"Pentaho Data Integration and Analytics","version":"0.0.1"},"components":{"schemas":{"UserList":{"type":"object","description":"List of users in the platform","properties":{"users":{"type":"array","description":"Array of usernames","items":{"type":"string"}}},"xml":{"name":"userList"}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.pentaho.com/rest-api/models.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
